#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <stdlib.h>
#include <pthread.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <sys/time.h>
#include "types.h"
#include "warpi.h"

cCLIENT	cclient;

struct  sockaddr_in     ccaddr;
pthread_t               hClientProcess;
pthread_mutex_t         ClientMutex;
int                     ClientWork;

I16	rdregs[_cnt_regs];
I16	wrregs[_cnt_regs];

int wConnect(char* ipaddr, int port)
{
    struct  hostent *ht;
    //
    cclient.socket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
    //
    if(cclient.socket < 0)
        return 1;
    ccaddr.sin_family = AF_INET;
    ccaddr.sin_port = htons(port);
    ht = gethostbyname((char*)(ipaddr));
    ccaddr.sin_addr.s_addr = *(ulong*)(ht->h_addr_list[0]);
    memset(&ccaddr.sin_zero, 0, 8);
    //
    if(connect(cclient.socket, (struct sockaddr *)&ccaddr, sizeof(ccaddr)) < 0)
        return 2;
    //mutex create
    if(!(pthread_mutex_init(&ClientMutex,NULL) == 0))
    {
        close(cclient.socket);
        return 3;
    }
    pthread_create(&hClientProcess, NULL, client_process, NULL);
    ClientWork = 1; //установка флага работы
    return 0;
}

int wDisconnect(void)
{
    ClientWork = 0;
    sleep(1);
    //pthread_mutex_lock(&ClientMutex);
    //close(cclient.socket);
    //pthread_mutex_unlock(&ClientMutex);

    return 0;
}

inline int cReadSocket(int nSocket, BYTE *pBuffer)
{
        //int     res                     = 1;
        int     	iRC                     = 0;
        int     	iReceiveStatus          = 0;
        int     	iStillToReceive         = 2; //начальный размер получения минимальных данных
        int     	iCount 	= 0;
        int		sz	= 0;
        struct timeval 	ReceiveTimeout;
        fd_set 		fds;
        U8		flag			= 0;
        //fcntl(nSocket, F_SETFL, O_NONBLOCK);
        //fds = calloc(1, sizeof(fd_set));// fds;
        //int size = 0;
        while(iStillToReceive > 0)
        {
                //установка величины таймаута
                FD_ZERO(&fds);
                FD_SET(nSocket, &fds);
                ReceiveTimeout.tv_sec  = 0;
                ReceiveTimeout.tv_usec = _SOCKET_TIMEOUT_;
                iRC = select(nSocket + 1, &fds, NULL, NULL, &ReceiveTimeout);
                //выход по таймауту
                if(!iRC)
            return -1;
        //произошла какая то ошибка
                if(iRC < 0)
                        return -2;
        //ошибка указания размера данных
                if(iStillToReceive <= 0)
                        return -3;
                //прием нескольких байт
        #if(_tcp_recv_deb == 1)
            printf("----read sock (recv) ----\r\n");
            #endif
        iReceiveStatus = recv(nSocket, (char*)(pBuffer), iStillToReceive, 0);
                if(iReceiveStatus >  0)
                {
            pBuffer += iReceiveStatus;
                        iStillToReceive -= iReceiveStatus;
                        iCount += iReceiveStatus;
            if((iCount >= 2) && (flag == 0))
            {
                //iStillToReceive = (*(U16*)(pBuffer - iCount)) - iCount;
                sz		= (*(U16*)(pBuffer - iCount));
                iStillToReceive = sz - iCount;
                #if(_tcp_recv_deb == 1)
                    printf("---recv size: set %i, count %i, still %i\r\n", (*(U16*)(pBuffer - iCount)), iCount, iStillToReceive);
                #endif
                flag = 0xFF;
            }
                }
        else if(iReceiveStatus == 0)
            return -1;
        else
            return -2;
        #if(_tcp_recv_deb == 1)
            printf("==iStillToReceive:%i iCount:%i==\r\n", iStillToReceive, iCount);
        #endif
        }
    //дополнительная проверка размера
    if(sz != iCount)
        return -3;
        //
        return iCount;
}


inline int cWriteSocket(int nSocket, BYTE *pBuffer, U16 iMessageLength)
{
    int 		iCount		= 0;
        int 		iSC 		= 0;
        int 		iSendStatus 	= 0;
        struct timeval 	SendTimeout;
        fd_set 		fds;
    //fcntl(nSocket, F_SETFL, O_NONBLOCK);
        while(iMessageLength > 0)
        {
        //установка величины таймаута
            SendTimeout.tv_sec  = 0;
            SendTimeout.tv_usec = _SOCKET_TIMEOUT_;
            FD_ZERO(&fds);
            FD_SET(nSocket, &fds);
                iSC = select(nSocket + 1, NULL, &fds, NULL, &SendTimeout);
                if(!iSC)
                        return -1; //таймаут
                if(iSC < 0)
                        return -2; //ошибка
        //отправить несколько байт
        #if(_tcp_send_deb == 1)
            printf("----write sock (send) ----\r\n");
                #endif
        iSendStatus = send(nSocket, (char*)(pBuffer), iMessageLength, 0);
                if(iSendStatus > 0)
                {
                        //обновить буфер и счетчик
                        iMessageLength -= iSendStatus;
                        pBuffer += iSendStatus;
                        iCount += iSendStatus;
                }
        else if(iSendStatus == 0)
            return -1;
        else
            return -2;
        }
    return iCount;
}



static void*  client_process(void * pr)
{
    U8	txbuf[_szbuf];
    U8	rxbuf[_szbuf];
    int	txsz = 0;
    int	res;
    while(ClientWork)
    {
        pthread_mutex_lock(&ClientMutex);
        //формирование запроса
        memcpy(&txbuf[_daddr], &wrregs[0], _cnt_regs * 2);
        txsz = _szbuf;
        (*(U16*)(&txbuf[_tcp_szl])) = txsz;
        txbuf[_type] = (_type_tcp_pkt_mask_rd | _type_tcp_pkt_mask_wr);
        //передача данных
        if(txsz > 0)
        {
            res = cWriteSocket(cclient.socket, &txbuf[0], txsz);
            switch(res)
            {
                case -2:
                    ClientWork = 0;
                    break;
                case 0:		//
                    break;
                default:
                    break;
            }
        }
        usleep(_conn_sleep);
        res = cReadSocket(cclient.socket, &rxbuf[0]);
        //приём данных
        switch(res)
        {
            case 0:	//Ok
                //countlive = setcntlive;
                //mworkr(&rxbuf[0]);
                break;
            case -1: //таймаут
                #if(_deb == 1)
                    printf("TCP client recv. timeout..\r\n");
                #endif
                break;
            case -2: //какая-то ошибка сокета
                #if(_deb == 1)
                    printf("TCP client resv. err?..\r\n");
                #endif
                goto mexit;
            case -3: //ошибка размера пакета
                //передача сообщения о несоответствии
                #if(_deb == 1)
                    printf("TCP client frame no correct..\r\n");
                #endif
                goto mexit; //отмена обработки запроса
            default: //нормально - данные приняты
                //обработка ответа
                memcpy(&rdregs[0], &rxbuf[_daddr], _cnt_regs * 2);
                break;
        }
        pthread_mutex_unlock(&ClientMutex);
        //
        usleep(_conn_sleep);
    }
mexit:	close(cclient.socket);
    ClientWork = 0;
    pthread_mutex_unlock(&ClientMutex);
    #if(_deb == 1)
        printf("mb1 disconnect\r\n");
    #endif
     pthread_exit(0);
}

//чтение статуса связи
int wCleintStatus(void)
{
    return ClientWork;
}

//чтение значения регистров
I16 wRdReg(int numreg)
{
    I16 val;
    pthread_mutex_lock(&ClientMutex);
    val = rdregs[numreg];
    pthread_mutex_unlock(&ClientMutex);
    return val;
}

//запись значения регистров
I16 wWrReg(int numreg, I16 val)
{
    pthread_mutex_lock(&ClientMutex);
    wrregs[numreg] = val;
    pthread_mutex_unlock(&ClientMutex);
    return val;
}
